#include <iostream>
#include <utility>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
	string rec = "nemoguce";
	int n, o, a, b, ab, kolicina;
	cin >> n;
	cin >> o >> a >> b >> ab;
	int kolicina_ab = 0;
	int proba_o = o; int proba_a = a; int proba_b = b;
	vector<pair<string, int>> parovi(n);

	for (int i = 0; i < n; i++) {
		string grupa;
		cin >> grupa >> kolicina;
		get<0>(parovi[i]) = grupa; get<1>(parovi[i]) = kolicina;

		if (grupa == "A") {
			if (kolicina > proba_a)
				proba_o -= (kolicina - proba_a);
			proba_a = max(0, proba_a - kolicina);
		} else if (grupa == "B") {
			if (kolicina > proba_b)
				proba_o -= (kolicina - proba_b);
			proba_b = max(0, proba_b - kolicina);
		} else if (grupa == "O")
			proba_o -= kolicina;
		else 
			kolicina_ab += kolicina;
	}
	int zbir = proba_a + proba_b + proba_o + ab;
	if (proba_o >= 0 && zbir >= kolicina_ab)
		rec = "moguce";
	
	cout << rec << endl;

	if (rec == "moguce") {
		for (auto par : parovi) {
			auto grupa = get<0>(par);
			kolicina = get<1>(par);
			if (grupa == "A") {
				int a_p = a; int o_p = o;
				if (kolicina > a)
					o -= (kolicina - a);
				a = max(0, a - kolicina);
				cout << o_p - o << " " << a_p - a << " " << 0 << " " << 0 << endl;
			}
			else if (grupa == "B") {
				int b_p = b; int o_p = o;
				if (kolicina > b)
					o -= (kolicina - b);
				b = max(0, b - kolicina);
				cout << o_p - o << " " << 0 << " " << b_p - b << " " << 0 << endl;
			}
			else if (grupa == "O") {
				int o_p = o;
				o -= kolicina;
				cout << o_p - o << " " << 0 << " " << 0 << " " << 0 << endl;
			} else {
				int a_p = a; int o_p = o; int b_p = b; int ab_p = ab;
				kolicina -= ab;
				ab = kolicina >= 0 ? 0 : ab - (kolicina + ab);
				if (kolicina > 0) {
					kolicina -= b;
					b = kolicina >= 0 ? 0 : b - (kolicina + b);
					if (kolicina > 0) {
						kolicina -= a;
						a = kolicina >= 0 ? 0 : a - (kolicina + a);
						if (kolicina > 0)
							o -= kolicina;
					}
				}
				cout << o_p - o << " " << a_p - a << " " << b_p - b << " " << ab_p - ab << endl;
			}
		}
	}
}